-------------------------------------------------------------------------------------
-- Derby Lua Script
-- By Bidwars
-------------------------------------------------------------------------------------

local M = {}
local lastVehicleClass = {}
local randomNumber = 0
math.randomseed(os.time())  --This is used for Random Math.
require('mathlib')
local function random(classCount)
	

	-- random generating 
	
	if randomNumber == 0 then
		math.random(); math.random(); math.random()
		randomNumber = math.random(1,classCount)
	elseif classCount > 2 then
		local v = classCount
		v = v / 2
		print("classCount Divided")
		if randomNumber >= v then
			randomNumber = randomNumber + 1
			print("a")
		else
			randomNumber = randomNumber - 1
			print("b")
		end
	end
	if randomNumber > classCount or randomNumber < 1 then
		print("c")
		randomNumber = math.random(1,classCount)
	end
	print(randomNumber)
	return randomNumber
end
-------------------------------------------------------------------------------------
--GETS A RANDOM VEHICLE JBEAM NAME
-------------------------------------------------------------------------------------
local function pcsName(vehicleClass)
	local r = 0
	local pcs = nil
	local custom = {"custom"}
	local randomv = {"coupe1","hatch1","pessima1","sunburst1","etkc1","miramar1","sbr1","coupe2","hatch2","pessima2","sunburst2","etkc2","miramar2","sbr2","coupe3","hatch3","pessima3","sunburst3","etkc3","miramar3","coupe4","hatch4","pessima4","sunburst4","etkc4","miramar4","legran1","etk8001","etki1","midsize1","super1","legran2","etk8002","etki2","midsize2","super2","legran3","etk8003","etki3","midsize3","super3","legran4","etk8004","etki4","midsize4","barstow1","fullsize1","moonhawk1","burnside1","barstow2","fullsize2","moonhawk2","burnside2","barstow3","fullsize3","moonhawk3","burnside3","barstow4","fullsize4","moonhawk4","burnside4","pickup1","van1","roamer1","pickup2","van2","roamer2","pickup3","van3","roamer3","pickup4"}
	local luxury = {"etkc1","etk8001","super1","sbr1","etkc2","etk8002","super2","sbr2","etkc3","etk8003","super3","etkc4","etk8004"}
	local compact = {"coupe1","hatch1","pessima1","etki1","sunburst1","miramar1","coupe2","hatch2","pessima2","etki2","sunburst2","miramar2","coupe3","hatch3","pessima3","etki3","sunburst3","miramar3","coupe4","hatch4","pessima4","etki4","sunburst4","miramar4"}
	local medium = {"legran1","pessima1","midsize1","sunburst1","legran2","sunburst2","pessima2","midsize2","legran3","pessima3","midsize3","sunburst3","legran4","pessima4","midsize4","sunburst4"}
	local large = {"barstow1","fullsize1","moonhawk1","burnside1","barstow2","fullsize2","moonhawk2","burnside2","barstow3","fullsize3","moonhawk3","burnside3","barstow4","fullsize4","moonhawk4","burnside4"}
	local truck = {"pickup1","van1","roamer1","pickup2","van2","roamer2","pickup3","van3","roamer3","pickup4"}
	local heavy	= {"semi1","semi2","semi3","semi4"}
	
	if vehicleClass == 8 then -- Custom Mods
		r = 1
		pcs = custom[r]
	elseif vehicleClass == 7 then --Random
		r = random(#randomv)
		pcs = randomv[r]
	elseif vehicleClass == 6 then -- Luxury Car
		r = random(#luxury)
		pcs = luxury[r]
	elseif vehicleClass == 5 then --Compact Car
		r = random(#compact)
		pcs = compact[r]
	elseif vehicleClass == 4 then --Medium Car
		r = random(#medium)
		pcs = medium[r]
	elseif vehicleClass == 3 then --Large Car
		r = random(#large)
		pcs = large[r]
	elseif vehicleClass == 2 then --Truck
		r = random(#truck)
		pcs = truck[r]
	else --Heavy
		r = random(#heavy)
		pcs = heavy[r]
	end

	return pcs
end
local function deleteParts(data,JBeam, partName)
	for _,part in ipairs(partName) do
		local hubcap = string.sub(part, 1, 6)
		if hubcap == "hubcap" then
			data.parts[part] = "none"
		elseif data.parts[JBeam..''..part] then
			data.parts[JBeam..''..part] = "none"
		end
	end
end
local function readPartsFile(File)
	local parts = readJsonFile(File)
	if parts then
		return parts
	end
end
-------------------------------------------------------------------------------------
--LOADS THE VEHICLE CLASS PC FILE
-------------------------------------------------------------------------------------
local function loadClass(vehicleClass, vehicleConfig, removePartsFile)
--local test = vehicles.getConfigList()
		--	dump(test)
	local JBeam = nil
	local pcs = pcsName(vehicleClass)
	local partConfig = nil
	local mods
	local number = tonumber(string.match(pcs, "%d+"))
	if pcs  == 'custom' then
			local F150Mod = {"derby37","derby44","derby55","derby62"}
			JBeam = 'moonhawk'
			local r = random(#F150Mod)
			mods = F150Mod[r]
			partConfig = string.format('levels/derby/vehicles/'..pcs..'/'..mods..'.pc', JBeam, mods)
			saveConfig = string.format('levels/derby/'..vehicleConfig..'_vehicles/'..pcs..'/v1'..mods..'.pc', JBeam, mods)
	else
		JBeam = pcs:sub(1, -2)
		local setup
		if vehicleConfig > 3 then
			setup = "stock"
		else 
			setup = "derby"
		end
		
		partConfig = string.format('levels/derby/vehicles/'..JBeam..'/'..setup..'_'..pcs..'.pc')
		saveConfig = string.format('levels/derby/'..vehicleConfig..'_vehicles/'..JBeam..'/'..setup..'_v1'..pcs..'.pc')
	end
	if vehicleConfig == 5 then --stock
		return JBeam, partConfig
	else
		local partsData = readPartsFile(partConfig)
		if vehicleConfig == 4 then --Derby2 
			deleteParts(partsData,JBeam,removePartsFile.derby2)
			--dump(partName)
			--local partName ={"_seats_R","_seat_FR","_mirror_R","_mirror_L","_innerfender_FR","_innerfender_FL","_glass","_exhaust_L","_exhaust_R","_doorpanel_L","_doorpanel_R","_exhaust","hubcap_F_16","hubcap_R_16","hubcap_R_15_alt","hubcap_F_15_alt","hubcap_R_15_altc","hubcap_F_15_altc","hubcap_F_15","hubcap_R_15","hubcap_F_14_alt","hubcap_R_14_alt","hubcap_F_14","hubcap_R_14","hubcap_F_13","hubcap_R_13","_antenna_trunk","_bumper_F_alt","_bumper_R_alt","_rallylights","_mudflap_R","_mudflap_L","_mudflap_FR","_mudflap_FL","_doorpanel_RL","_doorpanel_FL","_doorpanel_FR","_doorpanel_RR","_spoiler_window","_lip_F","_towhitch","_glass_wagon","_sparetire","_roofrack","_bedtoolbox_L","_bedtoolbox_R","_bedpipes","_glass_ext","_exhaust_v8","_muffler_ext","_bedextra","_muffler","_lightbar","_taillight_L","_taillight_R","_taillight","_lettering_v8","_lettering_hood","_grille","_headlight_R","_headlight_L","_lettering_DX","_rollcage","_lettering","_logo_F_grille","_fascia","_headlightcover_L","_headlightcover_R","_lettering_tailcone","_chrome","_spoiler","_logo_F","_logo_R","_logo_F_grille","_lettering_dxi","_lettering_trunk","_lettering_trunk_2400","_lettering_grille","_bumperlight_F","_bumperlight_R","_sideskirt","_trim_kit","_lights","_lipsignal","_foglight","_lettering_fender","_nosecone","_visor","_horn_R","_horn_L","_exhauststack_R","_exhauststack_L","_taillights_short","_hood_accessory","_tailcone","_tailcone_panel","_beaconlight","_roof_accessory","_trunk_accessory","_licenseplate_R","_licenseplate_F"} 
		end
		if vehicleConfig <= 3  then  --Derby
			deleteParts(partsData,JBeam,removePartsFile.derby)
	
			--local partName = {"_seats_R","_seat_FR","_mirror_R","_mirror_L","_innerfender_FR","_innerfender_FL","_glass","_bumper_F","_bumper_R","_exhaust_L","_exhaust_R","_doorpanel_L","_doorpanel_R","_exhaust","hubcap_F_16","hubcap_R_16","hubcap_R_15_alt","hubcap_F_15_alt","hubcap_R_15_altc","hubcap_F_15_altc","hubcap_F_15","hubcap_R_15","hubcap_F_14_alt","hubcap_R_14_alt","hubcap_F_14","hubcap_R_14","hubcap_F_13","hubcap_R_13","_antenna_trunk","_bumper_F_alt","_bumper_R_alt","_rallylights","_mudflap_R","_mudflap_L","_mudflap_FR","_mudflap_FL","_doorpanel_RL","_doorpanel_FL","_doorpanel_FR","_doorpanel_RR","_spoiler_window","_lip_F","_towhitch","_glass_wagon","_sparetire","_roofrack","_bedtoolbox_L","_bedtoolbox_R","_bedpipes","_glass_ext","_exhaust_v8","_muffler_ext","_bedextra","_muffler","_lightbar","_licenseplate_R","_licenseplate_F"} 
			--deleteParts(data,JBeam,partName)
		end
		if vehicleConfig <= 2 then --Stripped
			deleteParts(partsData,JBeam,removePartsFile.stripped)
			--local partName = {"reardoor_R","_door_RL_wagon","_door_RR_wagon","_door_FR_wagon","reardoor_L","_door_RR","_door_FR","_door_RL","_door_R","_taillight_L","_taillight_R","_taillight","_lettering_v8","_lettering_hood","_grille","_headlight_R","_headlight_L","_bumperbar_F","_bumperbar_R","_lettering_DX","_rollcage","_lettering","_logo_F_grille","_fascia","_headlightcover_L","_headlightcover_R","_lettering_tailcone","_chrome","_spoiler","_logo_F","_logo_R","_logo_F_grille","_lettering_dxi","_lettering_trunk","_lettering_trunk_2400","_lettering_grille","_bumperlight_F","_bumperlight_R","_sideskirt","_trim_kit","_lights","_lipsignal","_foglight","_lettering_fender","_nosecone","_visor","_horn_R","_horn_L","_exhauststack_R","_exhauststack_L","_taillights_short","_hood_accessory","_tailcone","_tailcone_panel","_beaconlight","_roof_accessory","_trunk_accessory"} 
			--deleteParts(data,JBeam,partName)
		end
		if vehicleConfig == 1 then --Low-End
		deleteParts(partsData,JBeam,removePartsFile.lowend)
			--local partName = {"_door_FL_wagon","_door_FL","_door_L","_seat_FL","_fender_R","_fender_L","_hood","_trunk","_tailgate","_gauges","_sidestep_L","_sidestep_R"}
			--deleteParts(data,JBeam,partName)
		end
	
		serializeJsonToFile(saveConfig, partsData, true)
	
	
		--print("loaded "..vName.." config"..JBeam.." "..pcs.."")
		return JBeam, saveConfig
	end
end

M.readPartsFile = readPartsFile
M.loadClass = loadClass
return M